/*
 * Copyright (C) 2016 Laboratoire ThéMA - UMR 6049 - CNRS / Université de Franche-Comté
 * http://thema.univ-fcomte.fr
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

package org.thema.lucsim.gui.generator.dt;

import au.com.bytecode.opencsv.CSVWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;
import java.util.Map;
import javax.swing.SpinnerNumberModel;
import org.thema.common.Util;
import org.thema.lucsim.engine.RulesBlock;
import org.thema.lucsim.generator.dt.TreeBinaryClassifier;
import org.thema.lucsim.generator.dt.RulesGeneratorDT.ClassifyRule;
import org.thema.lucsim.generator.dt.RulesGeneratorDT.SubCondition;
import org.thema.lucsim.gui.LucsimView;

/**
 * Window dialog displaying to the user the rules produced and the confusion
 * matrix of the built model.
 */
public class PostProcessDialog extends javax.swing.JDialog {

    private final TreeBinaryClassifier classifier;
    private RulesBlock rulesBlock;
    private final LucsimView lucsimView;
    private final Map<String, Integer> confusionMatrixFromTraining;
    private final Map<String, Integer> confusionMatrixFromTesting;
    private final List<ClassifyRule> rulesList;
    
    private static final String MCC = "Matthews correlation coefficient : %g";
    
    /**
     * Creates new form PostProcessDialog.
     *
     * @param parent parent frame of the dialog
     * @param classifier the tree classifier
     * @param lucsimView view of the project
     */
    public PostProcessDialog(java.awt.Dialog parent, TreeBinaryClassifier classifier, LucsimView lucsimView) {
        super(parent, false);
        this.lucsimView = lucsimView;
        this.classifier = classifier;
        
        initComponents();
        
        rulesList = classifier.getRulesGenerator().getRules();
        Collections.sort(rulesList);

        confusionMatrixFromTraining = classifier.getConfusionMatrixFromTrainingData();
        confusionMatrixFromTesting = classifier.getConfusionMatrixFromTestData();
        
        labelConfusionMatrixTesting.setVisible(confusionMatrixFromTesting != null);
        jScrollPane1.setVisible(confusionMatrixFromTesting != null);
        mccTestingLabel.setVisible(confusionMatrixFromTesting != null);
        
        fillComponents();
        setLocationRelativeTo(parent);
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        panelBackground = new javax.swing.JPanel();
        panelRules = new javax.swing.JPanel();
        labelRules = new javax.swing.JLabel();
        buttonApply = new javax.swing.JButton();
        jScrollPane2 = new javax.swing.JScrollPane();
        textAreaRules = new javax.swing.JTextArea();
        checkBoxFormatting = new javax.swing.JCheckBox();
        sizeLabel = new javax.swing.JLabel();
        jLabel1 = new javax.swing.JLabel();
        nbRuleSpinner = new javax.swing.JSpinner();
        jLabel2 = new javax.swing.JLabel();
        minPosSpinner = new javax.swing.JSpinner();
        statExtractButton = new javax.swing.JButton();
        factorRuleButton = new javax.swing.JButton();
        panelConfusionMatrix = new javax.swing.JPanel();
        labelConfusionMatrix = new javax.swing.JLabel();
        jScrollPane1 = new javax.swing.JScrollPane();
        tableConfusionMatrixFromTesting = new javax.swing.JTable();
        jScrollPane3 = new javax.swing.JScrollPane();
        tableConfusionMatrixFromTraining = new javax.swing.JTable();
        labelConfusionMatrixTraining = new javax.swing.JLabel();
        labelConfusionMatrixTesting = new javax.swing.JLabel();
        mccTrainingLabel = new javax.swing.JLabel();
        mccTestingLabel = new javax.swing.JLabel();
        buttonClose = new javax.swing.JButton();
        viewTreeButton = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle("Confusion matrix & rules");

        panelBackground.setName("panelBackground"); // NOI18N

        panelRules.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        panelRules.setName("panelRules"); // NOI18N

        labelRules.setFont(new java.awt.Font("Tahoma", 1, 18)); // NOI18N
        labelRules.setText("Rules");
        labelRules.setName("labelRules"); // NOI18N

        buttonApply.setText("Apply to the current project");
        buttonApply.setName("buttonApply"); // NOI18N
        buttonApply.setPreferredSize(new java.awt.Dimension(75, 25));
        buttonApply.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                buttonApplyActionPerformed(evt);
            }
        });

        jScrollPane2.setName("jScrollPane2"); // NOI18N

        textAreaRules.setColumns(20);
        textAreaRules.setRows(5);
        textAreaRules.setName("textAreaRules"); // NOI18N
        jScrollPane2.setViewportView(textAreaRules);

        checkBoxFormatting.setText("format");
        checkBoxFormatting.setName("checkBoxFormatting"); // NOI18N
        checkBoxFormatting.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                checkBoxFormattingActionPerformed(evt);
            }
        });

        sizeLabel.setText("size : ");
        sizeLabel.setName("sizeLabel"); // NOI18N

        jLabel1.setText("Keep best rules");
        jLabel1.setName("jLabel1"); // NOI18N

        nbRuleSpinner.setName("nbRuleSpinner"); // NOI18N
        nbRuleSpinner.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                nbRuleSpinnerStateChanged(evt);
            }
        });

        jLabel2.setText("Min. positive");
        jLabel2.setName("jLabel2"); // NOI18N

        minPosSpinner.setModel(new javax.swing.SpinnerNumberModel(1, 1, null, 1));
        minPosSpinner.setName("minPosSpinner"); // NOI18N
        minPosSpinner.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                minPosSpinnerStateChanged(evt);
            }
        });

        statExtractButton.setText("Extract stats");
        statExtractButton.setName("statExtractButton"); // NOI18N
        statExtractButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                statExtractButtonActionPerformed(evt);
            }
        });

        factorRuleButton.setText("Factor rules");
        factorRuleButton.setName("factorRuleButton"); // NOI18N
        factorRuleButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                factorRuleButtonActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout panelRulesLayout = new javax.swing.GroupLayout(panelRules);
        panelRules.setLayout(panelRulesLayout);
        panelRulesLayout.setHorizontalGroup(
            panelRulesLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(panelRulesLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(panelRulesLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jScrollPane2)
                    .addGroup(panelRulesLayout.createSequentialGroup()
                        .addComponent(labelRules)
                        .addGap(18, 18, 18)
                        .addComponent(sizeLabel, javax.swing.GroupLayout.PREFERRED_SIZE, 319, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addComponent(factorRuleButton)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(statExtractButton)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(checkBoxFormatting))
                    .addGroup(panelRulesLayout.createSequentialGroup()
                        .addComponent(jLabel1)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(nbRuleSpinner, javax.swing.GroupLayout.PREFERRED_SIZE, 72, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(32, 32, 32)
                        .addComponent(jLabel2)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(minPosSpinner, javax.swing.GroupLayout.PREFERRED_SIZE, 60, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addComponent(buttonApply, javax.swing.GroupLayout.PREFERRED_SIZE, 221, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addContainerGap())
        );
        panelRulesLayout.setVerticalGroup(
            panelRulesLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(panelRulesLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(panelRulesLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(labelRules)
                    .addComponent(checkBoxFormatting)
                    .addComponent(sizeLabel)
                    .addComponent(statExtractButton)
                    .addComponent(factorRuleButton))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jScrollPane2, javax.swing.GroupLayout.DEFAULT_SIZE, 275, Short.MAX_VALUE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(panelRulesLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(buttonApply, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel1)
                    .addComponent(nbRuleSpinner, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel2)
                    .addComponent(minPosSpinner, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addContainerGap())
        );

        panelConfusionMatrix.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        panelConfusionMatrix.setName("panelConfusionMatrix"); // NOI18N

        labelConfusionMatrix.setFont(new java.awt.Font("Tahoma", 1, 18)); // NOI18N
        labelConfusionMatrix.setText("Confusion matrix");
        labelConfusionMatrix.setName("labelConfusionMatrix"); // NOI18N

        jScrollPane1.setName("jScrollPane1"); // NOI18N

        tableConfusionMatrixFromTesting.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {null, "Positive", "Negative"},
                {"Positive", null, null},
                {"Negative", null, null}
            },
            new String [] {
                "Observed", "Predicted", "Predicted"
            }
        ) {
            Class[] types = new Class [] {
                java.lang.String.class, java.lang.Object.class, java.lang.Object.class
            };
            boolean[] canEdit = new boolean [] {
                false, false, false
            };

            public Class getColumnClass(int columnIndex) {
                return types [columnIndex];
            }

            public boolean isCellEditable(int rowIndex, int columnIndex) {
                return canEdit [columnIndex];
            }
        });
        tableConfusionMatrixFromTesting.setName("tableConfusionMatrixFromTesting"); // NOI18N
        jScrollPane1.setViewportView(tableConfusionMatrixFromTesting);

        jScrollPane3.setName("jScrollPane3"); // NOI18N

        tableConfusionMatrixFromTraining.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {null, "Positive", "Negative"},
                {"Positive", null, null},
                {"Negative", null, null}
            },
            new String [] {
                "Observed", "Predicted", "Predicted"
            }
        ) {
            Class[] types = new Class [] {
                java.lang.String.class, java.lang.Object.class, java.lang.Object.class
            };
            boolean[] canEdit = new boolean [] {
                false, false, false
            };

            public Class getColumnClass(int columnIndex) {
                return types [columnIndex];
            }

            public boolean isCellEditable(int rowIndex, int columnIndex) {
                return canEdit [columnIndex];
            }
        });
        tableConfusionMatrixFromTraining.setName("tableConfusionMatrixFromTraining"); // NOI18N
        jScrollPane3.setViewportView(tableConfusionMatrixFromTraining);

        labelConfusionMatrixTraining.setText("Confusion matrix for training data");
        labelConfusionMatrixTraining.setName("labelConfusionMatrixTraining"); // NOI18N

        labelConfusionMatrixTesting.setText("Confusion matrix for the testing data");
        labelConfusionMatrixTesting.setName("labelConfusionMatrixTesting"); // NOI18N

        mccTrainingLabel.setText("Matthews correlation coefficient : %g");
        mccTrainingLabel.setName("mccTrainingLabel"); // NOI18N

        mccTestingLabel.setText("Matthews correlation coefficient : %g");
        mccTestingLabel.setName("mccTestingLabel"); // NOI18N

        javax.swing.GroupLayout panelConfusionMatrixLayout = new javax.swing.GroupLayout(panelConfusionMatrix);
        panelConfusionMatrix.setLayout(panelConfusionMatrixLayout);
        panelConfusionMatrixLayout.setHorizontalGroup(
            panelConfusionMatrixLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(panelConfusionMatrixLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(panelConfusionMatrixLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(mccTrainingLabel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, panelConfusionMatrixLayout.createSequentialGroup()
                        .addGap(0, 0, Short.MAX_VALUE)
                        .addComponent(jScrollPane3, javax.swing.GroupLayout.PREFERRED_SIZE, 365, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(panelConfusionMatrixLayout.createSequentialGroup()
                        .addGroup(panelConfusionMatrixLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                            .addComponent(labelConfusionMatrix)
                            .addComponent(labelConfusionMatrixTraining)
                            .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 365, Short.MAX_VALUE)
                            .addComponent(labelConfusionMatrixTesting)
                            .addComponent(mccTestingLabel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                        .addGap(0, 0, Short.MAX_VALUE)))
                .addContainerGap())
        );
        panelConfusionMatrixLayout.setVerticalGroup(
            panelConfusionMatrixLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(panelConfusionMatrixLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(labelConfusionMatrix)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(labelConfusionMatrixTraining)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jScrollPane3, javax.swing.GroupLayout.PREFERRED_SIZE, 82, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(mccTrainingLabel)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addComponent(labelConfusionMatrixTesting)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 84, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(mccTestingLabel)
                .addGap(36, 36, 36))
        );

        buttonClose.setText("Close");
        buttonClose.setName("buttonClose"); // NOI18N
        buttonClose.setPreferredSize(new java.awt.Dimension(75, 25));
        buttonClose.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                buttonCloseActionPerformed(evt);
            }
        });

        viewTreeButton.setText("View tree");
        viewTreeButton.setName("viewTreeButton"); // NOI18N
        viewTreeButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                viewTreeButtonActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout panelBackgroundLayout = new javax.swing.GroupLayout(panelBackground);
        panelBackground.setLayout(panelBackgroundLayout);
        panelBackgroundLayout.setHorizontalGroup(
            panelBackgroundLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(panelBackgroundLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(panelBackgroundLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(panelBackgroundLayout.createSequentialGroup()
                        .addComponent(buttonClose, javax.swing.GroupLayout.PREFERRED_SIZE, 90, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addComponent(viewTreeButton, javax.swing.GroupLayout.PREFERRED_SIZE, 98, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(panelBackgroundLayout.createSequentialGroup()
                        .addComponent(panelConfusionMatrix, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(panelRules, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)))
                .addContainerGap())
        );
        panelBackgroundLayout.setVerticalGroup(
            panelBackgroundLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(panelBackgroundLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(panelBackgroundLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(panelRules, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(panelConfusionMatrix, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(panelBackgroundLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(buttonClose, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(viewTreeButton))
                .addContainerGap())
        );

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(panelBackground, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(panelBackground, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void fillComponents() {
                
        tableConfusionMatrixFromTraining.setValueAt((int)confusionMatrixFromTraining.get("TN"), 2, 2);
        tableConfusionMatrixFromTraining.setValueAt((int)confusionMatrixFromTraining.get("FP"), 2, 1);
        tableConfusionMatrixFromTraining.setValueAt((int)confusionMatrixFromTraining.get("FN"), 1, 2);
        tableConfusionMatrixFromTraining.setValueAt((int)confusionMatrixFromTraining.get("TP"), 1, 1);

        mccTrainingLabel.setText(String.format(MCC, calcMCC(confusionMatrixFromTraining)));
        
        if (confusionMatrixFromTesting != null) {
            tableConfusionMatrixFromTesting.setValueAt((int)confusionMatrixFromTesting.get("TN"), 2, 2);
            tableConfusionMatrixFromTesting.setValueAt((int)confusionMatrixFromTesting.get("FP"), 2, 1);
            tableConfusionMatrixFromTesting.setValueAt((int)confusionMatrixFromTesting.get("FN"), 1, 2);
            tableConfusionMatrixFromTesting.setValueAt((int)confusionMatrixFromTesting.get("TP"), 1, 1);

            mccTestingLabel.setText(String.format(MCC, calcMCC(confusionMatrixFromTesting)));
        }
        
        nbRuleSpinner.setModel(new SpinnerNumberModel(rulesList.size(), 1, rulesList.size(), 1));
        nbRuleSpinnerStateChanged(null);
    }
    
    private void buttonApplyActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_buttonApplyActionPerformed
        lucsimView.setTextRule(rulesBlock.toString());
    }//GEN-LAST:event_buttonApplyActionPerformed

    private void buttonCloseActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_buttonCloseActionPerformed
        setVisible(false);
        dispose();
    }//GEN-LAST:event_buttonCloseActionPerformed

    private void checkBoxFormattingActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_checkBoxFormattingActionPerformed
        if (checkBoxFormatting.isSelected()) {
            textAreaRules.setText(textAreaRules.getText()
                    .replace("or", "\n\t\tor"));
        } else {
            textAreaRules.setText(textAreaRules.getText()
                    .replace("\n\t\tor", "or"));
        }
    }//GEN-LAST:event_checkBoxFormattingActionPerformed

    private void viewTreeButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_viewTreeButtonActionPerformed
        classifier.renderTree();
    }//GEN-LAST:event_viewTreeButtonActionPerformed

    private void nbRuleSpinnerStateChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_nbRuleSpinnerStateChanged
        rulesBlock = new RulesBlock(RulesBlock.BlockType.SIMPLE);
        int size = 0;
        String ruleString = "/* Score\tTrue posit.\tFalse posit.\tNb conditions */\n";
        int tpTot = 0, fpTot = 0;
        int nbRule = 0;
        for(ClassifyRule rule : getSelectedRules()) {
            rulesBlock.add(rule.getRule());
            ruleString += String.format("/* %g\t%d\t%d\t%d */ %s\n", rule.getScore(), rule.getTp(), rule.getFp(), rule.getNbConditions(), rule.getRule().toString());
            tpTot += rule.getTp();
            fpTot += rule.getFp();
            size += rule.getNbConditions();
            nbRule++;
        }
        updateConfusionMatrix(tpTot, fpTot);
        sizeLabel.setText(String.format("rules : %d  conditions : %d", nbRule, size));
        textAreaRules.setText(ruleString);
    }//GEN-LAST:event_nbRuleSpinnerStateChanged

    private void minPosSpinnerStateChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_minPosSpinnerStateChanged
        nbRuleSpinnerStateChanged(evt);
    }//GEN-LAST:event_minPosSpinnerStateChanged

    private void statExtractButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_statExtractButtonActionPerformed
        File f = Util.getFileSave(".csv");
        if(f == null) {
            return;
        }
        try {
            writeStatRules(getSelectedRules(), f);
        } catch (IOException ex) {
            throw new RuntimeException(ex);
        }
    }//GEN-LAST:event_statExtractButtonActionPerformed

    private void factorRuleButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_factorRuleButtonActionPerformed
        textAreaRules.setText(classifier.getRulesGenerator().getFactorRule());
    }//GEN-LAST:event_factorRuleButtonActionPerformed

    private List<ClassifyRule> getSelectedRules() {
        List<ClassifyRule> rules = new ArrayList<>();
        for(ClassifyRule rule : rulesList.subList(0, (int) nbRuleSpinner.getValue())) {
            if(rule.getTp() >= (int) minPosSpinner.getValue()) {
                rules.add(rule);
            }
        }
        return rules;
    }
    
    public static void writeStatRules(List<ClassifyRule> rules, File f) throws IOException {
        List<String[]> stats = extractStatRules(rules);
        try (CSVWriter w = new CSVWriter(new FileWriter(f))) {
            w.writeNext(new String[]{"Rule", "Level", "Function", "State", "Radius", "Comparator", "Nb", "Weight", "TP", "FP"});
            for(String[] stat : stats) {
                w.writeNext(stat);
            }
        }
    }
    
    private static List<String[]> extractStatRules(List<ClassifyRule> selectedRules) {
        List<String[]> stats = new ArrayList<>();
        int indRule = 1;
        for(ClassifyRule rule : selectedRules) {
            int nbConditions = rule.getNbConditions();
            if(rule.getInitState() != null) {
                stats.add(new String[] {""+indRule, "0", "init", rule.getInitState().getName(), "0", "=", "", ""+1.0/nbConditions, ""+rule.getTp(), ""+rule.getFp()});
            }
            int indCond = 1;
            for(SubCondition cond : rule.getConditions()) {
                stats.add(new String[] {""+indRule, ""+indCond, cond.getFunction(), String.valueOf(cond.getState()), ""+cond.getRadius(), cond.getComp(), ""+cond.getNb(), ""+1.0/nbConditions, ""+rule.getTp(), ""+rule.getFp()});
                indCond++;
            }
            indRule++;
        }
        return stats;
    }
    
    /**
     * Return the optimal number of rules for maximizing MCC. Works only on training dataset
     * @param rules
     * @param confusionMatrixFromTraining
     * @return 
     */
    public static int optimMCC(List<ClassifyRule> rules, Map<String, Integer> confusionMatrixFromTraining) {
        Collections.sort(rules);
        
        double prevMcc = calcMCC(confusionMatrixFromTraining);
        int nbRule = rules.size();
        double mcc = prevMcc;
        int tpTot = confusionMatrixFromTraining.get("TP"), fpTot = confusionMatrixFromTraining.get("FP");
        while(mcc >= prevMcc && nbRule > 0) {
            nbRule--;
            tpTot -= rules.get(nbRule).getTp();
            fpTot -= rules.get(nbRule).getFp();
            prevMcc = mcc;
            mcc = calcMCC(confusionMatrixFromTraining, tpTot, fpTot);
        }
        return nbRule+1;
    }
    
    private void updateConfusionMatrix(int newTp, int newFp) {
        double tn = confusionMatrixFromTraining.get("TN");
        double fp = confusionMatrixFromTraining.get("FP");
        double fn = confusionMatrixFromTraining.get("FN");
        double tp = confusionMatrixFromTraining.get("TP");
        
        fn += tp - newTp;
        tn += fp - newFp;
        tp = newTp;
        fp = newFp;
        
        tableConfusionMatrixFromTraining.setValueAt((int)tn, 2, 2);
        tableConfusionMatrixFromTraining.setValueAt((int)fp, 2, 1);
        tableConfusionMatrixFromTraining.setValueAt((int)fn, 1, 2);
        tableConfusionMatrixFromTraining.setValueAt((int)tp, 1, 1);

        double mcc = (tp*tn - fp*fn) / Math.sqrt((tp+fp)*(tp+fn)*(tn+fp)*(tn+fn));
        mccTrainingLabel.setText(String.format(MCC, mcc));
    }
    
    private static double calcMCC(Map<String, Integer> confusionMatrix, int newTp, int newFp) {
        double tn = confusionMatrix.get("TN");
        double fp = confusionMatrix.get("FP");
        double fn = confusionMatrix.get("FN");
        double tp = confusionMatrix.get("TP");
        
        fn += tp - newTp;
        tn += fp - newFp;
        tp = newTp;
        fp = newFp;
        
        return (tp*tn - fp*fn) / Math.sqrt((tp+fp)*(tp+fn)*(tn+fp)*(tn+fn));
    }
    
    public static double calcMCC(Map<String, Integer> confusionMatrix) {
        double tn = confusionMatrix.get("TN");
        double fp = confusionMatrix.get("FP");
        double fn = confusionMatrix.get("FN");
        double tp = confusionMatrix.get("TP");
        
        return (tp*tn - fp*fn) / Math.sqrt((tp+fp)*(tp+fn)*(tn+fp)*(tn+fn));
    }
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton buttonApply;
    private javax.swing.JButton buttonClose;
    private javax.swing.JCheckBox checkBoxFormatting;
    private javax.swing.JButton factorRuleButton;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JScrollPane jScrollPane3;
    private javax.swing.JLabel labelConfusionMatrix;
    private javax.swing.JLabel labelConfusionMatrixTesting;
    private javax.swing.JLabel labelConfusionMatrixTraining;
    private javax.swing.JLabel labelRules;
    private javax.swing.JLabel mccTestingLabel;
    private javax.swing.JLabel mccTrainingLabel;
    private javax.swing.JSpinner minPosSpinner;
    private javax.swing.JSpinner nbRuleSpinner;
    private javax.swing.JPanel panelBackground;
    private javax.swing.JPanel panelConfusionMatrix;
    private javax.swing.JPanel panelRules;
    private javax.swing.JLabel sizeLabel;
    private javax.swing.JButton statExtractButton;
    private javax.swing.JTable tableConfusionMatrixFromTesting;
    private javax.swing.JTable tableConfusionMatrixFromTraining;
    private javax.swing.JTextArea textAreaRules;
    private javax.swing.JButton viewTreeButton;
    // End of variables declaration//GEN-END:variables
}